$(document).ready(function() {
	var time = 5000, activelightbox = "", slidetimer = "";
	
	//Eventy a bindy
	$('.images a').on("click", function(e) { //kliknutí na obrázek
		e.preventDefault(); //nechceme měnit hash
		rollLightbox($(this));
	});
	
	$('.overlay .box .close').on("click", function(e) { //zavřít
		e.preventDefault();
		closeLightbox();
	});
	
	$('.overlay .box .left').on("click", function(e) { //přechod vlevo
		e.preventDefault();
		moveTo(false);
	});
	
	$('.overlay .box .right').on("click", function(e) { //přechod vpravo
		e.preventDefault();
		moveTo(true);
	});
	
	$(window).resize(function() { //změna velikost obrazovky
		if(activelightbox !== "") {
			rollLightbox(activelightbox);
		}
	});
	
	$('.slideshow').on("click", function(e) {  //spustit slideshow
		e.preventDefault();
		startSlideshow();
	});
	
	$(document).keydown(function(e){ //klávesy
		switch(e.keyCode) {
			case 37: //vlevo
				moveTo(false);
				break;
			case 39: //vpravo
				moveTo(true);
				break;
			case 27: //esc
				closeLightbox();
				break;
		}
	});
	
	$('.overlay').on("click", function() {
		closeLightbox();
	});
	
	$('.box').on("click", function(e) {
		e.stopPropagation();
	});
	
	//hash detector
	window.onhashchange = handleHash;
	handleHash();
	
	function handleHash() {
		var hash = window.location.hash.replace("#","");
		
		if(hash !== "" && $.isNumeric(hash) && hash > 0 && hash <= $('.images a').size()) {
			rollLightbox($('.images a:nth-child('+hash+')'));
		}
	}
	

	
	function rollLightbox(img) { //načte LightBox
		var overlay = $('.overlay');
		var image = $('.box',overlay);
		
		
		//nastavit preloader, abychom mohli zjistit velikost obrázku bez server-side, CSS nejde, jelikož kdybychom nastavili ".images img" height 100%, tak se ten obrázek rozáthne i přes svoji velikost, což je ne-e
		var preloader = $('<img />').attr({"src":img.attr("href")}); //vytvoříme v paměti preloader, kterým zjistíme velikost
		var size = {x:0,y:0};
		
		preloader.one('load', function() {
			size.x = preloader[0].width; //outerHTML (aka. [0]) podporuje úplně každý prohlížeč
			size.y = preloader[0].height;
			
			activelightbox = img; //nastavíme právě vybraný element, tj kliknutý obrázek
			
			if(size.y > $(window).height()) { 
				size.x = size.x * $(window).height() / size.y; //výpočet toho, o kolik je zmenšený obrázek
				size.y = $(window).height();
			}	
			
			if(size.x > $(window).width()) { 
				size.y *= $(window).width() / size.x;
				size.x = $(window).width();
			}	
			
			window.location.hash = img.index() + 1; 
			
			image.css({
				"margin-left":("-"+Math.round(size.x/2)+"px"), 
				"margin-top":("-"+Math.round(size.y/2)+"px"),
				"width" : size.x,
				"height" : size.y
			}); //vycentrujeme obraz pomocí záporného marginu a nastavíme výšku
			
			$('img', image).replaceWith(preloader); //použijeme preloader k vykreslení
			
			validateMove(activelightbox);
			overlay.fadeIn(500); 
		
		}).each(function() { //někdy se tento event nespustí, když je třeba obrázek cachnutý
			if(this.complete) $(this).load();
		});
	}	
	
	function closeLightbox() {
		$('.overlay').fadeOut(500);
		activelightbox = "";
		clearTimeout(slidetimer);
	}
	
	function moveTo(next) {
		var possible = validateMove(activelightbox);
		
		if(next && possible.next) { //doprava
			rollLightbox(activelightbox.next()); 
		} else if (!next && possible.prev) { //doleva
			rollLightbox(activelightbox.prev()); 
		}
	}
	
	function validateMove(item) {	
		

		var possible = {next:(item.next().length != 0), prev:(item.prev().length != 0)};
		
		if(possible.next) {
			$('.overlay .right').show();
		} else {
			$('.overlay .right').hide();
		}
		
		if(possible.prev) {
			$('.overlay .left').show();
		} else {
			$('.overlay .left').hide();
		}
		
		return possible;
	}
	
	function startSlideshow() {
		activelightbox = "";
		moveSlideshow();
	}
	
	function moveSlideshow() {
		var next;
		
		if(activelightbox === "") {
			next = $('.images a:first');
		} else {
			next = activelightbox.next();
		}
		
		if(next.length != 0) {
			rollLightbox(next);	
		} else {
			rollLightbox($('.images a:first'));
		}
		
		slidetimer = setTimeout(moveSlideshow, time);
	}
	
	
});